<template>
  <div>
    <!-- 搬运任务历史 -->
    <p-card title="搬运任务历史">
      <span slot="extra">
        <!-- <p-button type="primary" style="margin-right:10px" @click="showmodel()">添加</p-button> -->
      </span>
      <p-grid-form :label-col="{ span: 8 }" :span="8" :items="config.items" @submit="hanlderSubmit" />
      <p-table
        ref="table"
        row-key="id"
        bordered
        :columns="config.columns"
        :remoteUrl="config.remoteUrl"
        :remoteParams="remoteParams"
        :doneBefore="doneBefore"
        :rowSelectType="false"
        :data-source="data"
        :scroll="{ x: 1500 }"
      >
        <template slot="operation" slot-scope="text, record">
          <!-- {{ text ? '禁用' : '启用' }} -->
          <a @click="detail(record)">查看详细</a>
          <!-- <a-divider type="vertical" /> -->
          <!-- <a @click="showmodel(text)">修改</a> -->
          <!-- <a-divider type="vertical" /> -->
          <!-- <a @click="del(text)">删除</a> -->
        </template>
      </p-table>
    </p-card>

    <p-modal
      title="详情"
      width="50%"
      :visible="visible"
      :confirm-loading="confirmLoading"
      @ok="handleOk"
      @cancel="handleCancel"
    >
      <p-grid-form :label-col="{ span: 8 }" ref="model" :span="8" :items="config.Modelitems" @submit="hanlderSubmit" />
    </p-modal>
    <p-modal
      title="详情"
      width="50%"
      :visible="visibleDetails"
      :confirm-loading="confirmLoading"
      @ok="visibleDetails = true"
      @cancel="handleCancel"
    >
      <a-descriptions bordered>
        <a-descriptions-item label="是否变更任务"> {{ detailInfo.isChangeTask ? '是' : '否' }} </a-descriptions-item>
        <a-descriptions-item label="是否取消任务"> {{ detailInfo.cleanTaskStatus ? '是' : '否' }} </a-descriptions-item>
        <a-descriptions-item label="优先级"> {{ detailInfo.priority }} </a-descriptions-item>
        <a-descriptions-item label="高度"> {{ detailInfo.height || 0 }} </a-descriptions-item>
        <a-descriptions-item label="重量"> {{ detailInfo.weight }} </a-descriptions-item>
        <a-descriptions-item label="业务属性"> {{ detailInfo.businessProperty || '暂无' }} </a-descriptions-item>
        <a-descriptions-item label="错误信息"> {{ detailInfo.errorMsg || '暂无' }} </a-descriptions-item>
      </a-descriptions>
    </p-modal>
  </div>
</template>

<script>
import config from './config.js'
import { diffOption } from '@/views/kzyWMS/utils/index.js'
import { stationadd, stationdelete, stationupdate } from './api'

export default {
  data() {
    return {
      config,
      data: [],
      type: true,
      remoteParams: {
        id: '',
        containerNo: '',
        taskType: '',
      },
      detailInfo: {},
      visible: false,
      visibleDetails: false,
      confirmLoading: false,
    }
  },
  mounted() {
    // this.getinfo()
  },
  created() {
    diffOption(this.config.columns).then((res) => {
      this.config.columns = res
    })
  },
  methods: {
    //查看详情
    detail(data) {
      console.log(data)
      this.detailInfo = data
      this.visibleDetails = true
    },
    //   taskId
    doneBefore(res) {
      //   res.data.list.forEach(item => {
      //     item.id = item.taskId
      //   })
      console.log(res)
      return res
    },
    hanlderSubmit(e, form) {
      e.preventDefault()
      form.validateFields((error, values) => {
        console.log(error, values, 'valuesvaluesvaluesvaluesvalues')
        // this.queryName = values.name
        // this.queryType = values.type
        // this.getlistCompanyByAuthId()
        if (!error) {
          this.remoteParams = { ...this.remoteParams, ...values }
        }
      })
    },
    handleOk(e) {
      this.$refs.model.form.validateFields(async (err, value) => {
        if (!err) {
          console.log(value)
          this.confirmLoading = true
          if (this.type) {
            let res = await stationupdate(value)
            console.log(res)
            if (res.success) {
              this.visible = false
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          } else {
            let res = await stationadd(value)
            console.log(res)
            if (res.success) {
              this.visible = false
              this.remoteParams = { ...this.remoteParams }
            } else {
              this.$exception(res)
            }
          }

          this.confirmLoading = false
          //
        }
      })
    },
    handleCancel(e) {
      console.log('Clicked cancel button')
      this.visible = false
      this.visibleDetails = false
    },
    //点击弹出
    showmodel(data) {
      console.log(data)
      this.visible = true

      if (data) {
        this.$nextTick(() => {
          this.$refs.model.form.setFieldsValue(data)
          this.$refs.model.form.setFieldsValue(data)
        })
        this.type = true
      } else {
        this.$nextTick(() => {
          this.$refs.model.form.resetFields()
        })
        this.type = false
      }
    },
    del(text) {
      let that = this
      console.log(text)
      this.$confirm({
        title: '确定是否要删除?',
        content: '',
        async onOk() {
          let res = await stationdelete({ id: text.id })
          if (res.success) {
            that.$message.success('删除成功')
            that.remoteParams = { ...that.remoteParams }
          } else {
            that.$exception(res)
          }
        },
        onCancel() {},
      })
    },
  },
}
</script>

<style lang="less" scoped></style>
